package org.maachang.dbm ;

/**
 * ベンチマーク用テスト.
 * 
 * @version 2008/05/28
 * @author masahito suzuki
 * @since MaachangDBM 1.11
 */
public class BTestProcess {
    
    /**
     * コンストラクタ.
     */
    private BTestProcess() {
        
    }
    
    /**
     * テスト.
     */
    public static final void main( String[] args ) throws Exception {
        MDbmManager.getInstance().open( "bTest" ) ;
        MDbm mdbm = MDbmManager.getInstance().getMDbm() ;
        int len = 1000000 ;
        System.out.println( "*** MDBM - bTest:" + len ) ;
        long tm = -1 ;
        
        tm = System.currentTimeMillis() ;
        for( int i = 0 ; i < len ; i ++ ) {
            String s = String.valueOf( i+1 ) ;
            s = "00000000".substring( s.length() ) + s ;
            s.getBytes() ;
        }
        long etc = System.currentTimeMillis() - tm ;
        System.out.println( "*** dataCreate - time:" + etc + "msec." ) ;
        
        tm = System.currentTimeMillis() ;
        for( int i = 0 ; i < len ; i ++ ) {
            String s = String.valueOf( i+1 ) ;
            s = "00000000".substring( s.length() ) + s ;
            byte[] b = s.getBytes() ;
            mdbm.put( b,b ) ;
        }
        tm = ( System.currentTimeMillis() - tm ) - etc ;
        System.out.println( "*** write - time:" + tm + "msec." ) ;
        
        tm = System.currentTimeMillis() ;
        for( int i = 0 ; i < len ; i ++ ) {
            String s = String.valueOf( i+1 ) ;
            s = "00000000".substring( s.length() ) + s ;
            byte[] b = s.getBytes() ;
            mdbm.get( b ) ;
        }
        tm = ( System.currentTimeMillis() - tm ) - etc ;
        System.out.println( "*** read - time:" + tm + "msec." ) ;
        
        mdbm.close() ;
    }
    
}
